#include <stdio.h>
#include <stdlib.h>
#include <string>
using namespace std;


char *strtrm(char *str, char delimiter);
char *strtoken(char* &inp, char delimiter);



void netlist2(FILE *in);


int main(int argc, char *argv[])
{
	char *filename;
	FILE *in;
	if (argc>1) {
		filename = argv[1];
		errno_t nerr = fopen_s(&in,filename,"r");
		if (nerr) {
			printf("file: %s not found\n",filename);
			return EXIT_FAILURE;
		}
	}
	else {
		filename = "stdin";
		in = stdin;
	}
	netlist2(in);
	fclose(in);
	return EXIT_SUCCESS;
}

void netlist2(FILE *in)
{
	char buf[512];
	char *inp, *token;
	bool done = false;
	int lines = 0;
	while (!done) {
		fgets(buf,511,in);
		if (feof(in)) return;
		lines++;
		strtrm(buf,'\n'); // terminate at newline character
		printf("line %d: %s\n",lines, buf);
		strtrm(buf,'%'); // terminate at comment character
		int n=0;
		inp = buf;
		string tok[16];
		while ((token=strtoken(inp,' '))!=0) {
			tok[n++] = token;
			printf("token %d: %s\n",n,token);
		}
	}
}
			
		